import { AfterViewInit, ElementRef, EventEmitter, OnChanges, OnInit, OnDestroy } from '@angular/core';
import { DomSanitizer, SafeStyle } from '@angular/platform-browser';
export declare class ColorPreviewComponent implements OnInit, OnChanges, AfterViewInit, OnDestroy {
    private sanitizer;
    private el;
    background: SafeStyle;
    rippleState: any;
    buttonState: any;
    relation: number;
    coefficient: number;
    color: string;
    size: number;
    confirm: EventEmitter<any>;
    get width(): "36px" | "70px";
    get height(): "36px" | "70px";
    onClick(): void;
    constructor(sanitizer: DomSanitizer, el: ElementRef);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnChanges(changes: any): void;
    rippleAnimationDone($event: any): void;
    buttonAnimationDone($event: any): void;
    ngOnDestroy(): void;
}
