import { Platform } from '@angular/cdk/platform';
import { AfterViewInit, ElementRef, EventEmitter, OnChanges, OnDestroy, OnInit, Renderer2, SimpleChanges } from '@angular/core';
import { Subscription } from 'rxjs';
export declare class RotatableDirective implements OnInit, OnChanges, OnDestroy, AfterViewInit {
    private el;
    private renderer;
    private platform;
    rotation: any;
    dragging: boolean;
    mouseDownSub: Subscription;
    mouseMoveSub: Subscription;
    mouseUpSub: Subscription;
    rect: any;
    cancelEv: string;
    mouseDownEv: string;
    mouseMoveEv: string;
    mouseUpEv: string;
    angle: number;
    disable: boolean;
    active: boolean;
    get isDisabled(): boolean;
    rotateStart: EventEmitter<any>;
    rotating: EventEmitter<any>;
    rotateStop: EventEmitter<any>;
    private point;
    private mouseUp$;
    private mouseOut$;
    constructor(el: ElementRef, renderer: Renderer2, platform: Platform);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngAfterViewInit(): void;
    initialRender(): void;
    rotationRender(): void;
    ngOnDestroy(): void;
    private applyRotation;
    private createPoint;
    private _normalizeX;
    private _normalizeY;
}
